local WaterMill = ...

--------------------------------------------------------------------------
local WATER_MILL_COMP_CHECK_WHEEL = {
	TypeName = WaterMillPrefix .. "_COMP_CHECK_WHEEL",
	ParentType = "COMPONENT",
	Properties = {
		{ Name = "FlagTerrain", Type = "integer", Default = 2 ^ OBJECT_FLAG.TERRAIN:toNumber() },
		{ Name = "FlagWater", Type = "integer", Default = 2 ^ OBJECT_FLAG.WATER:toNumber() }
	}
}

--------------------------------------------------------------------------
function WATER_MILL_COMP_CHECK_WHEEL:create()
	self._timer = 0
end

--------------------------------------------------------------------------
function WATER_MILL_COMP_CHECK_WHEEL:init()
        WaterMill:log("WATER_MILL_COMP_CHECK_WHEEL:init")
        local FromPosition = self:getOwner():getGlobalPosition()
        WaterMill:log("FromPosition = " .. tostring(FromPosition))
        local Delta = { FromPosition[1], self:checkWheelElevation(FromPosition), FromPosition[3] }

        WaterMill:log("Delta A0 = " .. tostring(Delta))
        WaterMill:log("FinalPosition = " .. tostring(self:getOwner():getGlobalPosition()))
        self:getOwner():setGlobalPosition(Delta)
        WaterMill:log("FinalPosition = " .. tostring(self:getOwner():getGlobalPosition()))
end

--------------------------------------------------------------------------
function WATER_MILL_COMP_CHECK_WHEEL:checkWheelElevation(_workerDestination)
    local raycastResult2 = {}
     
    -- Raycast from the building position Y - 100
    -- to building position Y + 100
    -- only on objects with a WATER or TERRAIN flag
    local FromPosition2 = { _workerDestination[1], _workerDestination[2]+100, _workerDestination[3] }
    local ToPosition2 = { _workerDestination[1], _workerDestination[2]-100, _workerDestination[3] }
    WaterMill:log("FromPosition2 = " .. tostring(FromPosition2) .. "ToPosition2 = " .. tostring(ToPosition2))
    if not self:getLevel():rayCast(FromPosition2, ToPosition2, raycastResult2, self.FlagWater + self.FlagTerrain) then
         WaterMill:logWarning("WaterMill: Bridge NOT on water")
         return _workerDestination[2]
    end
    WaterMill:log("final raycastResult2 = RigidBody = " .. tostring(raycastResult2["RigidBody"]) .. " Position = " .. tostring(raycastResult2["Position"]) .. " Normal = " .. tostring(raycastResult2["Normal"]))
    WaterMill:log("checkWaterElevation = " .. raycastResult2["Position"][2])
    return raycastResult2["Position"][2]
end

--------------------------------------------------------------------------
function WATER_MILL_COMP_CHECK_WHEEL:update()
end

--------------------------------------------------------------------------
WaterMill:registerClass(WATER_MILL_COMP_CHECK_WHEEL)
